#include "mbed.h"
#include "TSISensor.h"

    Ticker tick;  //definice prerusovace
        
    DigitalOut m1(PTD0);      //definice 4 vystupu pro rizeni krokoveho motorku
    DigitalOut m2(PTD5);
    DigitalOut m3(PTA13);
    DigitalOut m4(PTC12);
    DigitalOut right(PTD3);   //definice 2 vystupu pro rizeni smeru otaceni DC motorku
    DigitalOut left(PTD2);
    int step=0;               //definice globalnich promennych  
    float wait1=0;
    float threshold=0;
        
void flip()                        //obsluha preruseni prepina vinuti krokoveho motorku
         {
         wait1++; 
         if (wait1>=threshold+1)   //ovladani rychlosti prepinani vinuti podle 
         {                         //hodnoty drive vyctene ze slideru
          wait1=0;      
         step++;
         if (step>3 )
         step=0;
         
         if(left==1)       //otaceni vlevo
                {
         if (step==0)      //prvni stav vinuti
           {
             m1=0;
             m2=1;
             m3=1;
             m4=0;
           } 
         if (step==1)      //druhy stav vinuti
           {
             m1=0;
             m2=0;
             m3=1;
             m4=1;
           } 
           
         if (step==2)      //treti stav vinuti
           {
             m1=1;
             m2=0;
             m3=0;
             m4=1;
           }
           
           if (step==3)    //ctvrty stav vinuti
           {
             m1=1;
             m2=1;
             m3=0;
             m4=0;
           }
                }
          
          if(right==1)     //otaceni vpravo 
                {
         if (step==3)      //prvni stav vinuti
           {
             m1=0;
             m2=1;
             m3=1;
             m4=0;
           } 
         if (step==2)      //druhy stav vinuti
           {
             m1=0;
             m2=0;
             m3=1;
             m4=1;
           } 
           
         if (step==1)      //treti stav vinuti
           {
             m1=1;
             m2=0;
             m3=0;
             m4=1;
           }
           
           if (step==0)    //ctvrty stav vinuti
           {
             m1=1;
             m2=1;
             m3=0;
             m4=0;
           }
                }
            }
        } 
 
int main(void) {               //hlavni funkce
    
    DigitalOut ledr(LED_RED);  // definice vystupu pro RGB led
    DigitalOut ledb(LED_BLUE);
    DigitalOut ledg(LED_GREEN);
    wait(0.5);                 // zablikaji vsechny LED pro overeni 
    ledr=1;                    // funkcnosti desky FRDM-KL25Z
    ledb=1;
    ledg=1;
    wait(0.1);
    ledr=0;
    wait(0.1);
    ledr=1;
    wait(0.1);
    ledg=0;
    wait(0.1);
    ledg=1;
    wait(0.1);
    ledb=0;
    wait(0.1);
    ledb=1;
    wait(0.1);
         
    tick.attach(&flip, 0.006);   //obsluha preruseni se spusti kazdych 6ms
    PwmOut led_pwm(LED_BLUE);    //definice PWM vystupu pro modrou LED
    led_pwm.period_ms(5.0f);     //definice periody PWM vystupu pro modrou LED
    
    PwmOut motor_pwm(PTD1);      //definice pwm vystupu pro ovladani rychlosti DC motorku
    motor_pwm.period_ms(5.0f);   //definice periody PWM vystupu pro ovladani rychlosti DC motorku
    TSISensor tsi;               //definice promenne pro dotykovy senzor (slider)
    
    float x=1;                   //definice
    int timer=0;                 //dalsich promennych
    right=0;                     //pocatecni nastaveni smeru otaceni
    left=1;
        
    while (1) {                         //nekonecna smycka
        x =  1.0-tsi.readPercentage();  //cteni hodnoty z kapacitniho slideru
             
        if (x<0.98)                     //pokud se nekdo dotknul slideru, tak
        {                               //se aktualizuje hodnota PWM a delka prodlevy  
        led_pwm =  x;                   //mezi prepinanim vinuti krokoveho motorku 
        motor_pwm = x;
        threshold=50*x-2;
        }
        
        wait(0.1);                      //cekani
        timer++;
             
        if (timer>20)                   //zmena smeru otaceni obou motorku
                { 
           timer=0;
           right=!right;
           left=!left;
                }
              }                
return 0;
}

